Attribute VB_Name = "PvrGlobals"
' This program and its source code are placed in the public domain by the author Lewis Balentine.
' There are no warranties of any kind either expressed or implied.
'
' I use a lot of global variables. They are simple and I LIKE simple.
'
' Unfortunately GAMBAS does not support the use of globals.
' If this code is ported to GAMBAS then this file will have to be converted to a class.
' Of course with GAMBAS you will also need three or four projects as well.
' That will mean multiple copies of this file thus diminishing the value of haveing
' these values and functions in a seperate file.
'

' Lazy stuff----------------------------------------------
Public Const EOL As String = vbCrLf     ' End Of Line string
Public Const Q1 As String = "'"         ' Single Quote
Public Const Q2 As String = """"        ' Double Quote"
Public Const EQ1 = "\'"                 ' Escaped Single Quote
Public Const EQ2 = "\"""                ' Escaped Double Quote
'Public Const KW = 1                     ' KeyWild Version
Public Const KW = 0                     ' Public Domain Version

' Debugging Variables--------------------------------------
Public LogFile           As String      ' name and path of logfile
Public LogMsg            As String      ' used to hold debugging messages in proceedures
Public Dump              As Integer     ' debugging level for log file
Public NotePad           As String      ' Path and Filename for Text Editor
Public BigStr            As String      ' Work around for VB6 bug. See Function RtnXmlField.

' Operational Variabels-------------------------------------
Public ProgramMode        As Integer      ' used to detemine program operation mode
                                         '    ProgramMode= 0 is undefined
                                         '    ProgramMode= 1 is schedule <default>
                                         '    ProgramMode= 2 is play now  (not implimented)
                                         '    ProgramMode= 3 is copy only (not implimented)
Public CopyPath          As String       ' Target directory for Copy Only mode
Public CopyOnlyNo        As String       ' Increment to make file names Unique
Public Linux             As Boolean      ' Used to indocate we are running in the Linux Enviroment
Public Wine              As Boolean      ' Used to indocate we are running in the Linux Wine Enviroment
Public SchTasks          As String       ' This is the exicuteable program used to schedule OS tasks
                                         ' the default is schtasks.exe but may be specified in the INI file
Public XP                As Boolean      ' There are some difference for XP
                                         ' We establish if the OS is XP when we read the command line
Public XPPW              As String       ' XP schtasks.exe requires a password --- store it here
Public TunerLimit        As Integer      ' Number of simultaneously tuner streams (not implimented)
Public PlayListFile      As String       ' Playlist file used by Play Now Mode

                                        
' Cmd Line variabels-------------------------------------------
Public ArgCount          As Integer      ' number of Command Line arguments found
Public ArgStrs()         As String       ' Command Line arguments
Public CmdIniFile        As String       ' INI file specified on command line

'Variables for Ini File Name and Location----------------------
Public IniFileName       As String       ' The Name only of the IniFile
Public IniFilePath       As String       ' The Path only of the iniFile
Public IniFile           As String       ' The Path & Name of the iniFile

'Variables for TitanTV File Name and Location-------------------
Public TitanTVName       As String       ' The Name only of the TitanTV
Public TitanTVPath       As String       ' The Path only of the TitanTV
Public TitanTVFile       As String       ' The Path & Name of the TitanTV

'Variables Read from INI file------------------------------------
Public UtcOffset         As Double       ' offset in hours form Zulu
Public ShortTime         As Integer      ' time (in secods) to Shorten Duration
' Public InputPath       As String       ' Location of TitanTV files
' aka TitanTVPath  (see above)           ' Normally User's DoenLoad Directory
Public VlcProgram        As String       ' Full path and file name of VLC Program executable file
Public VLCinput          As String       ' VLC impt stream string
Public VLCoptions        As String       ' command line options for VLC
Public RunProgram        As String       ' program used to actually launch VLC at event trigger
Public WorkDir           As String       ' Location used for output files: CMD files, TXT files and Video Recordings
Public VideoDir          As String       ' Target Directory for finished recordings
Public SoutStrs()        As String       ' Sout Parameter Strings
Public SoutUse           As Integer      ' Default Sout String to use (index into SoutStrs)
Public SoutChn()         As String       ' Channel Specific Sout String to use (index into SoutStrs)
Public TitleFind()       As String       ' Sunstitution strings: Find This
Public TitleReplace()    As String       ' Sunstitution strings: Replace with This
Public PostProcessCmd    As String       ' Command to schedule after video is recorded
Public PostProcessDelay  As Integer      ' Delay after video is recorded
Public AppendDateTime    As Boolean      ' Allways append date and time to episode in show file name.
Public PrependDateTime   As Boolean      ' Allways prepend date and time to episode in to show file name.

'Variables Read from TVPI files ------------------------------------
Public TitanTvList()     As String       ' List of Files to process
Public ShowSourceFile    As String       ' Title of Show from TitanTv File
Public ShowTitle         As String       ' Title of Show from TitanTv File
Public ShowAltTitle      As String       ' Alternate tittle after substitutions
Public ShowEpisode       As String       ' Episode Title (may be empty)
Public ShowAltEpisode    As String       ' Alternate Episode after substitutions
Public ShowFileName      As String       ' FileName for show (without path and extension)
Public ShowFileExt       As String       ' Extension for show
Public ShowDscr          As String       ' Show Description (may be empty)
Public ShowStation       As String       ' Show Station Call Sign (from TitanTV)
Public ShowMajor         As String       ' psip-major
Public ShowMinor         As String       ' psip-Minor
Public ShowVirtChn       As String       ' Vitural channel in the form Major.Minor
Public ShowRfChn         As String       ' rf -channel
Public ShowStream        As String       ' stream-number
Public ShowStart         As Date         ' Start Date and Time of Show
Public ShowEnd           As Date         ' End Date and Time of Show
Public ShowDuration      As Integer      ' Show Duration in seconds (after ShortTime has beed subtracted)
Public ShowInStream      As String       ' This is the fully formatted VLC input stream
Public ShowOutStream     As String       ' This is the fully formatted VLC output stream
Public ShowTaskCmd       As String       ' This is the fully formatted Schedule Cmd Line
Public ShowPostProcess   As String       ' This is the fully formatted Schedule Post Process Cmd Line


'Variables For building Playlist ------------------------------------
Public PlayListBuffer    As String       ' This will hold the data until we write it to file.
Public PlayListTracks    As Integer      ' Count the number of tracks (i.e. Channels)
Public PlayListStr1      As String       ' Lazziness again
Public PlayListStr2      As String       ' Still Lazzy

' NOTES:
' ^ is the line continuation character for DOS/Windows CMD files
' \ is the line continuation character for Linux Shell files (ie bash or dash)

'===================================================================================================================
' These Functions and Subs may be used by various KW-PVR programs
'===================================================================================================================

Public Function LeftPad(Str As String, N As Integer) As String
    If N > Len(Str) Then
        LeftPad = Right(Space(N) & Str, N)
    Else
        LeftPad = Str
    End If
End Function

Public Function RightPad(Str As String, N As Integer) As String
    If N > Len(Str) Then
        RightPad = Left(Str & Space(N), N)
    Else
        RightPad = Str
    End If
End Function
Public Function TerminatePath(ByVal Path As String) As String
    ' This function was written with the concept of running the application in the wine enviroment
    ' Given a path such as "C:\Tempwork" this function
    ' returns a string with a termianting delimiter
    ' Example: "C:\Tempwork"
    Dim Work, C As String
    Work = Trim(Path)
    If InStr(Work, "/") > 0 Then
        C = "/"             ' abby normal
    Else
        C = "\"             ' normal
    End If
    If Right(Work, 1) <> C Then
        TerminatePath = Work & C
    Else
        TerminatePath = Work
    End If
End Function

Public Function RtnNameOnly(ByVal MyFileName As String) As String
    ' This function was written with the concept of running the application in the wine enviroment
    ' Given a Filename of the form
    ' "C:\My Direcotry\Filename.ext"
    '  or
    ' "\\Server\share\My Direcotry\Filename.ext"
    '  or
    ' "//Server/share/filename.ext"
    ' or
    ' "file://url/subdir/filename.ext"
    ' Return a string that only contains only the filename (and extension)
    Dim C As String
    If InStr(MyFileName, "/") Then
        C = "/"         ' abby normal
    Else
        C = "\"         ' normal
    End If
    
    Dim P As Integer
    P = InStrRev(MyFileName, C)
    If P > 0 Then
        RtnNameOnly = Trim(Mid(MyFileName, P + 1))
    Else
        RtnNameOnly = Trim(MyFileName)
    End If
    
End Function

Public Sub TestXP()
    ' There are some variations for the XP operating system
    ' We use a CHEAT to determine if the OS is Windows XP
    If InStr(Environ$("APPDATA"), "\Documents and Settings\") > 0 Then
        XP = True
    Else
        XP = False
    End If
End Sub

Public Function FindWorkDir() As String
    ' default to public Videos
    Call TestXP
    Dim Work, Work2 As String
    Work = ""
    ' Here we see Microsoft's failure to plan ahead ..... (not to mention total lack of consistancy)
    ' Back in the days of PC-DOS and MS-DOS the common directory names were: User, Data, Programs, DOS
    If XP Then
        Work = TerminatePath(TerminatePath(TerminatePath(Environ$("ALLUSERSPROFILE")) & "Documents") & "My Videos")
        ' The proper pronound in this case should be "Our" not "My"
        ' English must have been the programers second (or third) language.
        ' How do these things make it past the Quality Control program?
        ' Daaaaaaa.... it is Microsoft. There is no Quality Control.
        If Dir(Work, vbDirectory) = "" Then
            ' Try something else
            Work = TerminatePath(TerminatePath(TerminatePath(Environ$("USERPROFILE")) & "My Documents") & "My Videos")
            If Dir(Work, vbDirectory) = "" Then
                ' If all Else fails
                Work = TerminatePath(TerminatePath(Environ$("USERPROFILE")) & "My Documents")
            End If
        End If
    Else
        Work = TerminatePath(TerminatePath(Environ$("PUBLIC")) & "Recorded TV")
        If Dir(Work, vbDirectory) = "" Then
            Work = TerminatePath(TerminatePath(Environ$("PUBLIC")) & "Videos")
            If Dir(Work, vbDirectory) = "" Then
                Work = TerminatePath(TerminatePath(Environ$("USERNAME")) & "Videos")
                If Dir(Work, vbDirectory) = "" Then
                    Work = TerminatePath(TerminatePath(Environ$("USERPROFILE")) & "Documents")
                End If
            End If
        End If
    End If
    
    If (Right(Work, 3) = "TV\") Or (Right(Work, 2) = "TV") Then
        ' do nothing
    Else
        ' Try to make the directory
        Work2 = Work & "Recorded TV"
        On Error Resume Next
        MkDir (Work2)
        On Error GoTo 0
        If Dir(Work2, vbDirectory) <> "" Then Work = Work2
    End If
    
    If Work <> "" Then
        FindWorkDir = TerminatePath(Work)
    Else
        FindWorkDir = ""
    End If
End Function
    
Public Function FindUserDownloads() As String
    Call TestXP
    Dim Work, Work2 As String
    Work = ""
    ' Microsoft could not be consistent if their corporate survival depended on it.
    If XP Then
        ' This where they should be ...
        Work = TerminatePath(Environ$("USERPROFILE")) & "My Documents\Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        ' If not then we try a few other ideas ....
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "Documents\Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "My Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "My Documents\My Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
    Else
        ' This where they should be ...
        Work = TerminatePath(Environ$("USERPROFILE")) & "Downloads"
        ' If not then we try a few other ideas ....
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "My Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "My Documents\My Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "My Documents\Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "Documents\My Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(Environ$("USERPROFILE")) & "Documents\Downloads"
        If Dir(Work, vbDirectory) = "" Then Work = ""
    End If
    If Work <> "" Then
        FindUserDownloads = TerminatePath(Work)
    Else
        FindUserDownloads = ""
    End If
End Function

Public Function FindVLCexe() As String
    ' Find the VLC program
    Dim Work, Work2 As String
    Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "VideoLAN") & "VLC") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "VideoLAN") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "VLC") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "KW-PVR") & "VLC") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "KW-PVR") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "C:\Program Files\VideoLAN\VLC\vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "C:\Program Files (x86)\VideoLAN\VLC\vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "C:\VideoLAN\VLC\vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "C:\VLC\vlc.exe"
    If Dir(Work) = "" Then Work = ""
    ' Tell me someone did not install VLC in the root of the main system drive.
    If Work = "" Then Work = "C:\vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(App.Path) & "VLC") & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(App.Path) & "vlc.exe"
    If Dir(Work) = "" Then Work = ""
    FindVLCexe = Work
End Function

Public Function FindRunProgram() As String
    ' Find the VLC program
    Dim Work, Work2 As String
    Work = ""
    ' Find the KW-PVR RUN program
    ' This is where it should be ...
    If Work = "" Then Work = TerminatePath(App.Path) & "kw-pvr-run.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "KW-PVR") & "kw-pvr-run.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(TerminatePath(Environ$("ProgramFiles")) & "VideoLAN") & "KW-PVR") & "kw-pvr-run.exe"
    If Dir(Work) = "" Then Work = ""
    FindRunProgram = Work
End Function

Public Function FindSchTasks() As String
    Dim Work, Work2 As String
    Work = ""
    If Work = "" Then Work = TerminatePath(Environ$("SystemRoot")) & "schtasks.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("SystemRoot")) & "system32") & "schtasks.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("SystemRoot")) & "system") & "schtasks.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("SystemRoot")) & "SysWOW64") & "schtasks.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "schtasks.exe"    ' let OS hunt for it
    FindSchTasks = Work
End Function

Public Function FindNotepad() As String
    Dim Work, Work2 As String
    Work = ""
    If Work = "" Then Work = TerminatePath(Environ$("SystemRoot")) & "notepad.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = TerminatePath(TerminatePath(Environ$("SystemRoot")) & "system32") & "notepad.exe"
    If Dir(Work) = "" Then Work = ""
    If Work = "" Then Work = "notepad.exe"        ' let OS hunt for it
    FindNotepad = Work
End Function

Public Function FindIniFile() As String
    ' Default: C:\Documents and Settings\<USERNAME>\Application Data\kw-pvr\kw-pvr.ini
    Dim Work, Work2 As String
    Work = ""
    ' was it specified on the command line ?
    
    If CmdIniFile <> "" Then
        Work = CmdIniFile
        If RtnNameOnly(Work) = Work Then
            ' we have no path
            Work = TerminatePath(TerminatePath(Environ$("APPDATA")) & "kw-pvr") & CmdIniFile
            If Dir(Work) = "" Then Work = ""
            If Work = "" Then Work = TerminatePath(App.Path) & CmdIniFile
            If Dir(Work) = "" Then Work = ""
        Else
            If Dir(Work) = "" Then Work = ""
        End If
    Else
        Work = TerminatePath(TerminatePath(Environ$("APPDATA")) & "kw-pvr") & "kw-pvr.ini"
        If Dir(Work) = "" Then Work = ""
        If Work = "" Then Work = TerminatePath(App.Path) & "kw-pvr.ini"
        If Dir(Work) = "" Then Work = ""
    End If
    FindIniFile = Work
End Function








