Attribute VB_Name = "KwPrvCfg"
' This program and its source code are placed in the public domain by the author Lewis Balentine.
' There are no warranties of any kind either expressed or implied.
' As a matter of lazziness there are three more files for this program:
'       kw-Pvr-Globals.Bas      Contains Public statements for Global Variables


Sub Main()
    ' From kw-Pvr-Globals.Bas
    ' Public IniFileName       As String       ' The Name only of the IniFile
    ' Public IniFilePath       As String       ' The Path only of the iniFile
    ' Public IniFile           As String       ' The Path & Name of the iniFile
    ' We are going to put the default INI file in the current user's App Data Directory
    
    ' for debugging
    'Call ObscureTest
    'End
    
    Call TestXP
    Call LookForIniFile
    Call ReadIniFile
    ' Shell ("Notepad.exe " & IniFile)
    Load kwPvrCfgForm
    kwPvrCfgForm.Show (1)
    End
    
End Sub
Sub LookForIniFile()
    Dim Work As String
    CmdIniFile = Trim(Command)
    If CmdIniFile <> "" Then
        ' remove double quotes if they exist
        If Left(CmdIniFile, 1) = Q2 Then CmdIniFile = Mid(CmdIniFile, 2)
        If Right(CmdIniFile, 1) = Q2 Then CmdIniFile = Left(CmdIniFile, Len(CmdIniFile) - 1)
        CmdIniFile = Trim(CmdIniFile)
    End If
    ' create the application data directory if it does not exist
    Work = TerminatePath(Environ$("APPDATA")) & "kw-pvr"
    If Dir(Work, vbDirectory) = "" Then MkDir (Work)
    
    Work = FindIniFile
    If Work = "" Then
        ' We need to create an INI file
        If CmdIniFile <> "" Then
            ' Is there a path included ?
            If RtnNameOnly(CmdIniFile) = CmdIniFile Then
                ' There is no Path ... add application data direcotry
                IniFile = TerminatePath(TerminatePath(Environ$("APPDATA")) & "kw-pvr") & CmdIniFile
            Else
                IniFile = CmdIniFile
            End If
        Else
            ' Set the default
            IniFile = TerminatePath(TerminatePath(Environ$("APPDATA")) & "kw-pvr") & "kw-pvr.ini"
        End If
        Call CreateIniFile
    Else
        IniFile = Work
    End If
    
End Sub
Sub SaveIniFileChanges()
    ' XPPW = Trim(XPPWText.Text)
    ' UtcOffset = Val(Trim(UtcText.Text))
    ' VlcText.Text = Trim(VlcText.Tag)
    Dim Str, SaveStr, Work, KeyStr, ValStr As String
    Dim P, F, F2 As Integer
    Dim Found0, Found1, Found2 As Boolean
    
    Found0 = False
    Found1 = False
    Found2 = False
    ' See if we have a backup file and delete it
    Work = IniFile & ".backup"
    If Dir(Work) <> "" Then Kill (Work)
    Name IniFile As Work
    DoEvents
    Close
    F = FreeFile
    Open Work For Input As F
    F2 = FreeFile
    Open IniFile For Output As F2
    
    While Not EOF(F)
        KeyStr = ""
        ValStr = ""
        Line Input #F, Str
        SaveStr = Str
        Str = Replace(Str, Chr(9), Space(1))
        If (Trim(Str) = "; End of File") Or (Trim(Str) = "; End of INI file") Or (Trim(Str) = "; EOF") Then
            ' Do nothing
        Else
            Work = Trim(Str)
            If Work <> "" Then
                P = InStr(Work, ";")
                If P = 1 Then Work = ""
                If P > 1 Then Work = Trim(Left(Work, P - 1))
            End If
            If Work <> "" Then
                P = InStr(Work, "=")
                If P > 1 Then
                    KeyStr = LCase(Trim(Left(Work, P - 1)))
                    'Debug.Print KeyStr, "";
                    ValStr = Trim(Mid(Work, P + 1))
                    'Debug.Print ValStr
                End If
            End If
            
            Select Case KeyStr
                Case ""
                    ' move on
                Case "xppw"
                    If XPPW <> "" Then
                        SaveStr = "  XPPW = " & PwObscure(Environ("USERNAME")) & " " & PwObscure(XPPW)
                    End If
                    If XP = False Then SaveStr = ""
                    Found0 = True
                Case "utcoffset"
                    If UtcOffset <> 0 Then
                        X = TypeName(UtcOffset)
                        SaveStr = "  UTCoffset = " & CStr(UtcOffset)
                    End If
                    Found1 = True
                Case "vlcinput"
                    If VLCinput <> "" Then
                        SaveStr = "  VLCinput = " & VLCinput
                    End If
                    Found2 = True
                Case Else
                    ' move on
            End Select
            Print #F2, SaveStr
        End If
    Wend
    ' Belts and Suspenders
    If Found0 = False And XP Then Print #F2, "  XPPW = " & PwObscure(Environ("USERNAME")) & " " & PwObscure(XPPW)
    If Found1 = False And UtcOffset <> 0 Then Print #F2, "  UTCoffset = " & CStr(UtcOffset)
    If Found2 = False And VLCinput <> "" Then Print #F2, "  VLCinput = " & VLCinput
    Print #F2, "; End of File"
    Close
    
End Sub

Sub ReadIniFile()
    ' We want two strings form the ini file
    ' UTCoffset
    ' VLCinput
    ' If XP then we also need XPPW
    Dim Str, Work, KeyStr, ValStr As String
    Dim P, F As Integer
    XPPW = ""
    UtcOffset = 0
    VLCinput = ""
    WorkDir = ""
    F = FreeFile
    Open IniFile For Input As #F
    While Not EOF(F)
        KeyStr = ""
        ValStr = ""
        Line Input #F, Str
        Str = Replace(Str, Chr(9), Space(1))
        Work = Trim(Str)
        If Work <> "" Then
            P = InStr(Work, ";")
            If P = 1 Then Work = ""
            If P > 1 Then Work = Trim(Left(Work, P - 1))
        End If
        If Work <> "" Then
            P = InStr(Work, "=")
            If P > 1 Then
                KeyStr = LCase(Trim(Left(Work, P - 1)))
                'Debug.Print KeyStr, "";
                ValStr = Trim(Mid(Work, P + 1))
                'Debug.Print ValStr
            End If
        End If
        
        Select Case KeyStr
            Case ""
                ' move on
            Case "xppw"
                XPPW = ValStr
            Case "utcoffset"
                UtcOffset = Val(ValStr)
            Case "vlcinput"
                VLCinput = ValStr
            Case "workdir"
                WorkDir = ValStr
            Case Else
                ' move on
        End Select
    Wend
    Close
End Sub

Sub CreateIniFile()
    ' This is used by Kw-PVR-Cfg.exe to create the inital ini file is one is not found.
    '--------------
    Dim F                   As Integer
    F = FreeFile
    Open IniFile For Output As #F
    Print #F, "; kw-pvr INI file for user " & Environ("USERNAME")
    Print #F, "; Created " & Format(Now, "dd mmm yyyy Hh:Nn")
    Print #F, ";"
    Print #F, "; KeyWild.com PVR (personal video recorder) processes TitanTV program files (*.tvpi or *.tvvi)"
    Print #F, "; to play and/or record and/or post process an scheduled TV broadcast via the VLC program."
    Print #F, ";     *** There are no warranties of any kind either expressed or implied. ***"
    Print #F, ";"
    Print #F, "; See " & Q2 & "kw-pvr-ini.txt" & Q2 & " for detailed notes about INI options."
    Print #F, "; " & Q2 & "kw-pvr-ini.txt" & Q2 & " should be located in Application directory: " & Q2 & App.Path & Q2
    Print #F, ";"
    Print #F, ""
    Print #F, "============================================="
    Print #F, "=== These are MUST HAVE options =============================================================="
    Print #F, "============================================="
    Print #F, ""
    Print #F, ""
    ' OK now what do we want in it ??
    If XP Then
        Print #F, ""
        Print #F, "  XPPW = "
        Print #F, ";      XP Username and Password (obscured)"
        Print #F, ";      ****      For Windows XP THIS IS A MUST HAVE OPTION     ****"
        Print #F, ";      **** This option is ignored if the OS is not Windows XP ****"
    End If
    '
    Print #F, ""
    Print #F, "UtcOffset ="
    Print #F, ";          **** THIS IS A MUST HAVE OPTION ****"
    Print #F, "; TitanTV uses GMT (a.k.a. UTC) time and date format. This is the number of hours needed"
    Print #F, "; to convert to local time (including daylight savings if applicable), Fractional units"
    Print #F, "; can be used for really strange time zones ...."
    Print #F, "; US Eastern Time = -4.0 (abby normal = daylight savings)"
    Print #F, "; US Central Time = -5.0 (abby normal = daylight savings)"
    Print #F, "; US Eastern Time = -5.0 (normal)"
    Print #F, "; US Central Time = -6.0 (normal)"
    '
    Print #F, ""
    Print #F, "VLCinput = "
    Print #F, ";          **** THIS IS A MUST HAVE OPTION ****"
    Print #F, "; This is line used to specify the input stream for your device."
    Print #F, ";    Example: http://192.168.0.201:5004/auto/v<#channel#>?dlna"
    Print #F, "; The line shown above is for the Silcon Dust HDHomeRun device."
    Print #F, "; The trick here is that '<#channel#>' will be replaced with the "
    Print #F, "; virtual channel number. You can copy this from VLC by"
    Print #F, "; menu select: Tools, Information."
    Print #F, "; The needed string is located in the box at the bottom labeled"; " "
    Print #F, ";      Location:"
    Print #F, ";"
    Print #F, "; In an effort to allow for other (unknown to me) tuner hardware"
    Print #F, "; the following are valid substituions:"
    Print #F, ";      <#rf#>      = rf-channel"
    Print #F, ";      <#major#>   = psip-major"
    Print #F, ";      <#minor#>   = psip-minor"
    Print #F, ";      <#stream#>  = stream-number"
    Print #F, ";      <#station#> = station (per TitanTV)"
    Print #F, ";      <#channel#> = virtual channel number"
    Print #F, ";"
    Print #F, ""
    Print #F, "============================================="
    Print #F, "=== These are SHOULD HAVE options =============================================================="
    Print #F, "============================================="
    ' The rest of this stuff we add to avoid looking it up everytime the program runs ....
    '
    Print #F, ""
    Print #F, "  WorkDir = " & FindWorkDir
    Print #F, "; Working Recording directory. This is where the video will be recorded."
    Print #F, "; The video Information XML files are written here as well."
    Print #F, ""
    Print #F, ""
    '
    Print #F, "  InputPath = " & FindUserDownloads
    Print #F, "; This path where the browser saves TitanTV files."
    Print #F, "; Normally this is the user's 'Downloads' directory."
    Print #F, ""
    Print #F, ""
    '
    Print #F, "  VLCProgram = " & FindVLCexe
    Print #F, "; Full path and file name of VLC Program executable file."
    Print #F, ""
    Print #F, ""
    '
    Print #F, "  RunProgram = " & FindRunProgram
    Print #F, "; Full path and file name of KW-PVR-RUN Program executable file."
    Print #F, "; This programs reads the XML file and lauches VLC."
    Print #F, "; Its primary purpose is to circumvent the 255 character command limit"
    Print #F, "; of Microsoft's schtasks.exe program."
    Print #F, ""
    Print #F, ""
    '
    Print #F, "  SchTasks = " & FindSchTasks
    Print #F, "; This is the program to be used with the OS task schedule."
    Print #F, "; It is defined here to allow for a substitute program."
    Print #F, ""
    Print #F, ""
    Print #F, ";==VLC SOUT============================================================================================"
    Print #F, "; VLC uses the --sout parameter to set the output location,"
    Print #F, "; container, resolution, codecs, cropping, etc of the output file."
    Print #F, "; This INI file allows for several different variations to be saved."
    Print #F, "; The key name is in the form 'SOUT = XX String' where XX is in the range of"
    Print #F, "; 01 to 99 and String is the -sout option parameter line."
    Print #F, ";"
    Print #F, "; --sout=file/ts:'<#filename#>.ts'"
    Print #F, "; This is the simplest command and is the default if no other SOUT options are defined."
    Print #F, "; It uses the TS (transport Stream) multiplexer, MPEG1/2 video Codec,"
    Print #F, "; This is hardcoded as sout string '00'."
    Print #F, ";"
    Print #F, "; The trick here is that '<#filename#>' will be replaced with the scheduled show's filename (with the path)."
    Print #F, "; -----------------------------------------------------------------------------------------------------"
    Print #F, ";"
    Print #F, "  SOUT = 01 --sout=#transcode{vcodec=mp2v,vb=1600,scale=1.00}:std{access=file,mux=ts,dst='<#filename#>.ts'"
    Print #F, "; This version specifies MPEG2 codec without any rescaling"
    Print #F, ";"
    Print #F, "  SOUT = 02 --sout=#transcode{vcodec=mp2v,vb=1500,scale=0.50}:std{access=file,mux=ts,dst='<#filename#>.ts'"
    Print #F, "; This version specifies MPEG2 codec with video down sized to one half"
    Print #F, ";"
    Print #F, "  SOUT = 03 --sout=#transcode{vcodec=mp2v,vb=1300,scale=0.33}:std{access=file,mux=ts,dst='<#filename#>.ts'"
    Print #F, "; This version specifies MPEG2 codec with video down sized to one third"
    Print #F, ";"
    Print #F, "  SOUT = 04 --sout=#transcode{vcodec=h264,vb=1000,scale=0.25,acodec=mpga,ab=128,channels=2,samplerate=44100}:std{access=file,mux=mp4,dst='<#filename#>.mov'}"
    Print #F, "; This line invokes the H264 Codec with video down sized to one fourth and saves the file in the mp4 format with the .mov extension"
    Print #F, ";"
    Print #F, "  SOUT.USE = 00"
    Print #F, "; This is the default SOUT line to use."
    Print #F, ";"
    Print #F, ";"
    '
    Print #F, "============================================="
    Print #F, "=== Everthing below here is optional =============================================================="
    Print #F, "============================================="
    Print #F, ""
    Print #F, "  VLCOptions ="
    Print #F, "; Any valid set of VLC CLI (command line interface) options (except input stream, --sout and --run-time)."
    Print #F, "; Note: If this option is defined then it OVERRIDES the default options."
    Print #F, "; The default is:"
    Print #F, ";   --no-crashdump --play-and-exit --qt-start-minimized --qt-notification=0"
    Print #F, ""
    '
    Print #F, ""
    Print #F, "  PrependDateTime ="
    Print #F, "  AppendDateTime ="
    Print #F, "; The show file name is normally made of the 'Alt  Show Title', a comma ',' and the 'Alt Show Episode'."
    Print #F, "; If the 'Episode' is not defined in the TitanTV file then 'Alt Show Episode' becomes the date and time"
    Print #F, "; of the show start in the format 'yymmdd-HhNn'. That should provide a unique name for every show."
    Print #F, ";"
    Print #F, "; However to err on the side of caution this option will prepend or append the date time to the 'Alt ShowEpisode'."
    Print #F, "; Or you may desire to always have the data and time in the file name --- the choice is up to you."
    Print #F, "; The LAST one in the INI file with a 'True' value take presedence."
    Print #F, "; Must be blank, 'True' or 'Yes'."
    Print #F, ""
    Print #F, ""
    '
    Print #F, ""
    Print #F, ";  VideoDir = "
    Print #F, ";  ShortTime = "
    Print #F, ";  NotePad = "
    Print #F, ";  CopyOnly = "
    Print #F, ";  CopyPath =  ; only needed for CopyOnly mode."
    Print #F, ";  PlayMode = "
    Print #F, ";  PostProcessCmd = "
    Print #F, ";  PostProcessDelay = "
    Print #F, ";  TunerLimit = "
    Print #F, ";  Replace = "
    Print #F, ""
    Print #F, "; End of INI file"
    Close
    
End Sub

























