Attribute VB_Name = "Obscure"
' Two Simple functions to Obscure and unobscure a String
' Minimal security --- this can be broken without too much effort.
'
' If you are producing your own version of KW-PVR from source then
' it hightly recomened that you come up with a better multi-level
' scheme to obscure the XP password. The Public Domain functions
' below are provided only as a simple replacements for the more
' secure proprietary KW functions.
' Also please do not use the key begin and end letters "K" and "W".
'
' Do not get too carried away.
' There are numerous programs to extract the password from Windows XP.

Public Function ObscureTest()
    ' This function used only for development testing
    Dim Work As String
    Work = "ABCDEFHIJKLMNOPQRSTUVWXYZ"
    Work = " " & Work & LCase(Work) & "0123456789@#$%^&*~" & " "
    'Work = "password"
    'Work = ""
    Debug.Print ""
    Debug.Print Work
    Work = PwObscure(Work)
    Debug.Print Work
    Work = PwReveal(Work)
    Debug.Print Work
End Function

Public Function PwObscure(StrIn As String) As String
    ' Public Domain Version
    Dim Work1, Work2, W As String
    Dim I, L As Integer
    Work1 = Trim(StrIn)
    If Work1 = "" Then
        PwObscure = "PD"
        Exit Function
    End If
    
    If KW = 1 Then
        ' call proprietary version
        PwObscure = XyObscure(Work1)
    Else
        Work2 = ""
        L = Len(Work1)
        For I = 1 To L
            W = Mid(Work1, I, 1)
            Work2 = Work2 & Format(Asc(W), "000")
        Next I
        Work2 = "P" & Work2 & "D"
        PwObscure = Work2
    End If
        
End Function

Public Function PwReveal(StrIn As String) As String
    ' Public Domain Version
    Dim Work1, Work2, W As String
    Dim I, L As Integer
    Work1 = Trim(StrIn)
    If (Work1 = "") Or (Work1 = "PD") Then
        PwReveal = ""
        Exit Function
    End If
        
    If (Left(Work1, 1) = "X") And (Right(Work1, 1) = "Y") Then
        ' call proprietary version
        PwReveal = XyReveal(Work1)
        Exit Function
    End If
    
    If (Left(Work1, 1) = "P") And (Right(Work1, 1) = "D") Then
        Work2 = ""
        If Len(Work1) > 1 Then Work1 = Mid(Work1, 2)
        While Len(Work1) > 2
            Work2 = Work2 & Chr(Val(Left(Work1, 3)))
            Work1 = Mid(Work1, 4)
        Wend
        PwReveal = Work2
        Exit Function
    End If
    
    ' If we get this far then Houston we have a problem
    PwReveal = ""
    
End Function

Private Function XyObscure(ByVal StrIn As String) As String
    ' proprietary version
End Function

Private Function XyReveal(ByVal StrIn As String) As String
    ' proprietary version
End Function
